diff --git a/src/base/async/int.c b/src/base/async/int.c
index b564e5562a..741cda7bbb 100644
--- a/src/base/async/int.c
+++ b/src/base/async/int.c
@@ -69,7 +69,7 @@ static int int33_hooked;
 
 static int int33(void);
 static int _int66_(int);
-static void do_rvc_chain(int i, int stk_offs, uint16_t *ret_p);
+static void do_rvc_chain(int i, int stk_offs);
 static void int21_rvc_setup(void);
 static void int2f_rvc_setup(void);
 static void int33_rvc_setup(void);
@@ -216,8 +216,7 @@ static void revect_helper(int stk_offs)
 {
     int ah = HI(ax);
     int subh = LO(bx);
-    int stk = (HI(bx) >> 4) + (_BP - _SP);
-    int ret_off = HI(bx) & 0x0f;
+    int stk = HI(bx) + stk_offs;
     int inum = ah;
     uint16_t old_ax;
     uint16_t old_flags;
@@ -242,7 +241,7 @@ static void revect_helper(int stk_offs)
 	}
 	break;
     case DOS_SUBHELPER_RVC_CALL:
-	do_rvc_chain(inum, stk, LINEAR2UNIX(SEGOFF2LINEAR(_SS, _BP - ret_off)));
+	do_rvc_chain(inum, stk);
 	break;
     case DOS_SUBHELPER_RVC2_CALL:
 	old_ax = LWORD(ecx);
@@ -2458,31 +2457,26 @@ static void do_int_from_hlt(Bit16u i, void *arg)
     }
 }
 
-static void do_rvc_chain(int i, int stk_offs, uint16_t *ret_p)
+static void do_rvc_chain(int i, int stk_offs)
 {
-    uint16_t old_ip = _IP;
     int ret = run_caller_func(i, REVECT, stk_offs);
-    *ret_p = ret;
     switch (ret) {
     case I_SECOND_REVECT:
 	di_printf("int_rvc 0x%02x setup\n", i);
-	/* make sure no one executed any call-back */
-	assert(_IP == old_ip);
 	if (int_handlers[i].secrevect_function) {
 	    /* if function supported, CF will be cleared on success, but for
 	     * unsupported functions it will stay unchanged */
 	    CARRY;
 	} else {
 	    assert(can_revector(i) == NO_REVECT);
-	    *ret_p = I_NOT_HANDLED;
 	}
-	break;
+	/* no break */
     case I_NOT_HANDLED:
 	di_printf("int 0x%02x, ax=0x%04x\n", i, LWORD(eax));
-	assert(_IP == old_ip);
+	set_ZF();
 	break;
     case I_HANDLED:
-	di_printf("int 0x%02x, ax=0x%04x handled\n", i, LWORD(eax));
+	clear_ZF();
 	break;
     }
 }
diff --git a/src/base/bios/x86/bios.s b/src/base/bios/x86/bios.s
index 8b3b512333..e70cc4e709 100644
--- a/src/base/bios/x86/bios.s
+++ b/src/base/bios/x86/bios.s
@@ -834,7 +834,6 @@ int_rvc_cs_\inum:
 	lret
 
 31: /* handler */
-	enterw $2,$0
 	pushl %eax
 	pushl %ebx
 	shll $16,%eax
@@ -842,26 +841,17 @@ int_rvc_cs_\inum:
 	movb $DOS_HELPER_REVECT_HELPER,%al
 	movb $DOS_SUBHELPER_RVC_CALL,%bl
 	movb $0x\inum,%ah
-	movb $(8<<4|2),%bh		/* stack offsets bp-rel */
+	movb $14,%bh		/* stack offset */
 	int $DOS_HELPER_INT
 	movw %bx,(%esp)
 	popl %ebx
 	movw %ax,(%esp)
 	popl %eax
-	pushfw
-
-	cmpw $1,-2(%bp)
-	je 9f			/* handled */
-	cmpw $2,-2(%bp)
-	je 2f			/* second_revect */
-	popfw
-	leavew
+	jnz 9f			/* handled */
+	jc 2f			/* second_revect */
 	ljmp *%cs:int_rvc_data_\inum
 
 2:
-	popfw		/* resync flags */
-	pushfw
-
 	pushw %ax
 	pushfw
 	lcall *%cs:int_rvc_data_\inum
@@ -876,11 +866,11 @@ int_rvc_cs_\inum:
 	shll $16,%edx
 	clc
 	movw 16(%esp),%cx	/* old AX */
-	movw 18(%esp),%dx	/* old flags */
+	movw 22(%esp),%dx	/* old flags */
 	movb $DOS_HELPER_REVECT_HELPER,%al
 	movb $DOS_SUBHELPER_RVC2_CALL,%bl
 	movb $0x\inum,%ah
-	movb $(8<<4|2),%bh		/* stack offsets bp-rel */
+	movb $24,%bh		/* stack offset */
 	int $DOS_HELPER_INT
 	movw %dx,(%esp)
 	popl %edx
@@ -890,25 +880,20 @@ int_rvc_cs_\inum:
 	popl %ebx
 	movw %ax,(%esp)
 	popl %eax
-	/* below replaces addw $4,%sp to not corrupt CF, remove ax,flags */
-	movl %eax,(%esp)
-	popl %eax
-	jmp 99f
+	/* below replaces addw $2,%sp to not corrupt CF */
+	movw %ax,(%esp)
+	popw %ax
 
 9:
-	popfw
-99:
 	jc 11f
 20:
-	leavew
 	andw $0xfffe,4(%esp)	/* clear CF */
 	iret
 11:
-	leavew
 	orw $1,4(%esp)		/* set CF */
 	iret
 12:
-	addw $4,%sp		/* skip saved ax,flags */
+	addw $2,%sp		/* skip saved ax */
 	jmp 20b
 .endm
 
